function dim=dimR2d(x,sigma,voices,Nmin,Nmax,kernelReg,mirror,reg)


[N,P]=size(x);


if mirror
  x=[mtlb_fliplr(x),x,mtlb_fliplr(x)];
  x=[mtlb_flipud(x);x;mtlb_flipud(x)];
  mirror=1;
end


jmax=voices;
iv=round(logspace(log10(Nmin),log10(Nmax),jmax));
imax=round(max(iv));
K=find(mtlb_diff(iv));
iv=[iv(K),imax];
jmax=length(iv);
////////////////////////////////////
//a:scale
//////////////////////////////////
a=[];
L=[];
Lnoisy=[];
R=[];


for j=1:jmax
  ii=round(iv(j));
  execstr(('[dzx,dzy,aa]='+ kernelReg+ '2dprimconv(x,iv(j));'));
  a(j)=aa;
  dzx=dzx(ii+1+mirror*(N-floor(iv(j)/2)) ...
      :N+mirror*(N+ii-floor(iv(j)/2)), ...
      ii+1+mirror*(P-floor(iv(j)/2)) ...
      :P+mirror*(P+ii-floor(iv(j)/2)));
  dzy=dzy(ii+1+mirror*(N-floor(iv(j)/2)) ...
      :N+mirror*(N+ii-floor(iv(j)/2)), ...
      ii+1+mirror*(P-floor(iv(j)/2)) ...
      :P+mirror*(P+ii-floor(iv(j)/2)));
  dlx=abs(dzx);
  dly=abs(dzy);
  dl=dlx+dly;
  if isempty(dl)
    break;
  end
  if sigma >0
    Lnoisy(j)=mean(mean(dl));
    execstr(('[dz,aa]='+ kernelReg+ '2dconv1(dzx,dzy,iv(j));'));
    a(j)=aa;
    dl=abs(dz);
    LRT=mean(mean(dl));
    //////////////////////////
    // signal/noise component rate
    ////////////////////////
    s=sigma/sqrt(sqrt(2*%pi)*a(j)^3);
    dln=2*s/sqrt(%pi).*exp(-(dl.^2)./s^2);
    //dlnx=2*s/sqrt(pi).*exp(-(dlx.^2)./s^2);
    //dlny=2*s/sqrt(pi).*exp(-(dly.^2)./s^2);
    //dln=dlnx+dlny;
    //dlsbx=dlx-dlnx;
    //dlsby=dly-dlny;
    dlsb=dl-dln;
    R(j)=mean(mean(dln))/LRT;
    //////////////////
    //Corrected unbiased lengths
    //////////////////
    //c=ones(1,ii)./ii;
    //dlsbmx=convol2(1,c,dlsbx);
    //dlsbmx=dlsbmx(ii:size(dlsbx,1),ii:size(dlsbx,2));
    //dlsbcx=s*sqrt(2)*invfonc(dlsbmx./(s*sqrt(2)));
    //dlsbmy=convol2(c,1,dlsby);
    //dlsbmy=dlsbmy(ii:size(dlsby,1),ii:size(dlsby,2));
    //dlsbcy=s*sqrt(2)*invfonc(dlsbmy./(s*sqrt(2)));
    //L(j)=mean(mean(dlsbcx))+mean(mean(dlsbcy));
    L(j)=mean(mean(dlsb))*Lnoisy(j)/LRT;
  else
    L(j)=mean(mean(dl))+(max([N,P]))^(-2);
  end
end


dim=reg_dimR(a,L,Lnoisy,R,reg,sigma,2);




