#include "C-LAB_Interf.h"

/* scilab interface */

/* INTERFACE ROUTINE */

typedef void func ();
typedef void (*funcH) ();

extern func  LAB_beep, 
  LAB_bbch,      LAB_linearlt,      LAB_lepskiiap,      LAB_monolr,      LAB_cwt,      LAB_alphagifs,      LAB_sgifs,      LAB_prescalpha,      LAB_fif,      LAB_binom,      LAB_sbinom,      LAB_multim1d,      LAB_multim2d,      LAB_smultim1d,      LAB_smultim2d,      LAB_readgif,      LAB_FWT,      LAB_IWT,      LAB_WTDwnHi,      LAB_WTDwnLo,      LAB_fch1d,      LAB_fcfg1d,      LAB_mch1d,      LAB_mcfg1d,      LAB_cfg1d,      LAB_FWT2D,      LAB_IWT2D,      LAB_mdzq1d,      LAB_mdzq2d,      LAB_reynitq,      LAB_mdfl1d,      LAB_sim_stable,      LAB_McCulloch,      LAB_Koutrouvelis,      LAB_stable_sm,      LAB_stable_test,      LAB_stable_cov,      LAB_holder2d,      LAB_gifseg,      LAB_wave2gifs,   LAB_gifs2wave;



static funcH TAB[]= {
  /* 1 */    LAB_beep,
  /* 2 */    LAB_bbch,
  /* 3 */    LAB_linearlt,
  /* 4 */    LAB_lepskiiap,
  /* 5 */    LAB_monolr,
  /* 6 */    LAB_cwt,
  /* 7 */    LAB_alphagifs,
  /* 8 */    LAB_sgifs,
  /* 9 */    LAB_prescalpha,
  /* 10 */    LAB_fif,
  /* 11 */    LAB_binom,
  /* 12 */    LAB_sbinom,
  /* 13 */    LAB_multim1d,
  /* 14 */    LAB_multim2d,
  /* 15 */    LAB_smultim1d,
  /* 16 */    LAB_smultim2d,
  /* 17 */    LAB_readgif,
  /* 18 */    LAB_FWT,
  /* 19 */    LAB_IWT,
  /* 20 */    LAB_WTDwnHi,
  /* 21 */    LAB_WTDwnLo,
  /* 22 */    LAB_fch1d,
  /* 23 */    LAB_fcfg1d,
  /* 24 */    LAB_mch1d,
  /* 25 */    LAB_mcfg1d,
  /* 26 */    LAB_cfg1d,
  /* 27 */    LAB_FWT2D,
  /* 28 */    LAB_IWT2D,
  /* 29 */    LAB_mdzq1d,
  /* 30 */    LAB_mdzq2d,
  /* 31 */    LAB_reynitq,
  /* 32 */    LAB_mdfl1d,
  /* 33 */    LAB_sim_stable,
  /* 34 */    LAB_McCulloch,
  /* 35 */    LAB_Koutrouvelis,
  /* 36 */    LAB_stable_sm,
  /* 37 */    LAB_stable_test,
  /* 38 */    LAB_stable_cov,
  /* 39 */    LAB_holder2d,
  /* 40 */    LAB_gifseg,
  /* 41 */    LAB_wave2gifs,
  /* 42 */    LAB_gifs2wave
};

void C2F(fraclab_interf)()
{
  InterfInit();
  (*TAB[Interf.FuncIndex-1])();
  InterfDone();
}
